<?php

/*
   _____ __    _                          __     ___    ____  ____
  / ___// /_  (_)___  __  __  ____  ___  / /_   /   |  / __ \/  _/
  \__ \/ __ \/ / __ \/ / / / / __ \/ _ \/ __/  / /| | / /_/ // /  
 ___/ / / / / / /_/ / /_/ / / / / /  __/ /_   / ___ |/ ____// /   
/____/_/ /_/_/ .___/\__, (_)_/ /_/\___/\__/  /_/  |_/_/   /___/   
            /_/    /____/                                         

API Versiyon: 2
Güncelleme Tarihi: 27.07.2020
*/

$allowedIps = json_decode(file_get_contents('https://shipy.net/security/whitelist'), true);

if(isset($_SERVER["HTTP_CLIENT_IP"])) {
	$clientIp = $_SERVER["HTTP_CLIENT_IP"];
} else if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])){
	$clientIp = $_SERVER["HTTP_X_FORWARDED_FOR"];
} else if (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) {
	$clientIp = $_SERVER["HTTP_CF_CONNECTING_IP"];
} else {
	$clientIp = $_SERVER["REMOTE_ADDR"];
}

if (!in_array($clientIp, $allowedIps)) { // IP Adresini kontrol ediyoruz, eğer istek shipy sunucusu üzerinden gelmemişse, sonlandırıyoruz. 
    exit("SHIPY: Request sent by wrong IP: " . $clientIp);
}

if (!isset($_POST["returnID"]) || !isset($_POST["paymentType"]) || !isset($_POST["paymentAmount"]) ||
!isset($_POST["paymentHash"]) || !isset($_POST["paymentID"]) || !isset($_POST["paymentCurrency"])) {
	// Herhangi veri eksik ise, isteği sonlandırıyoruz.
	exit("SHIPY: Missing value sent.");
}

$apiKey = "secret"; // Gizli API anahtarınız

$paymentID = $_POST["paymentID"]; // Shipy tarafından belirlenmiş işlem ID'si
$returnID = $_POST["returnID"]; // Ödeme isteğini gönderirken belirlediğiniz return id
$paymentType = $_POST["paymentType"]; // Ödeme kanalı. "eft" => Havale / EFT, "credit_card" => Kredi Kartı / Ön Ödemeli Kart, "mobile" => Mobil Ödeme
$paymentAmount = $_POST["paymentAmount"]; // Ödeme yapılan tutar
$paymentCurrency = $_POST["paymentCurrency"]; // Ödeme yapılan para birimi
$paymentHash = $_POST["paymentHash"]; // Shipy tarafından gönderilen hash

$hashtr = $paymentID . $returnID . $paymentType . $paymentAmount . $paymentCurrency . $apiKey;
$hashbytes = mb_convert_encoding($hashtr, "ISO-8859-9");
$hash = base64_encode ( sha1 ( $hashbytes, true ) );

if($hash!=$paymentHash) 
{
    http_response_code(403);
    exit(json_encode(array("status"=>"error","message"=>"paymentHash is not vaild.")));
}

// Her şey doğrulandı ve güvenli. Artık burada veritabanı işlemlerinizi yapabilirsiniz.

echo "OK"; // İşlem sonunda OK yazdırıyoruz. Eğer yazdırılmazsa, OK yanıtı gelene kadar tarafınıza istek gönderilecektir.

?>
